"use strict";
const debug_1 = require("debug");
const mqtt_1 = require("mqtt");
require("../../lib/mqtt/topic");
const myDebug = debug_1.debug('egg-mqtt:app:extend:application.js');
const MqttIOSymbol = Symbol.for('EGG-MQTT#mqtt');
const RouterConfigSymbol = Symbol.for('EGG-MQTT#ROUTERCONFIG');
module.exports = {
    get mqtt() {
        if (!this[MqttIOSymbol]) {
            this.config.mqtt.options = this.config.mqtt.options || {};
            const client = mqtt_1.connect(this.config.mqtt.brokerUrl);
            try {
                client.route = (topic, handler) => {
                    if (!this[RouterConfigSymbol]) {
                        this[RouterConfigSymbol] = new Map();
                    }
                    if (!this[RouterConfigSymbol].has(topic)) {
                        myDebug('[egg-mqtt] set router config: ', topic);
                        this[RouterConfigSymbol].set(topic, handler);
                        this.mqtt.subscribe(topic, (err => {
                            if (err) {
                                this.logger.debug(err);
                            }
                        }));
                    }
                };
            }
            catch (e) {
                this.logger.error(e);
            }
            this[MqttIOSymbol] = client;
        }
        return this[MqttIOSymbol];
    }
};
