import {debug} from 'debug';
import {connect, MqttClient} from 'mqtt'
import '../../lib/mqtt/topic'

const myDebug = debug('egg-mqtt:app:extend:application.js')
const MqttIOSymbol = Symbol.for('EGG-MQTT#mqtt');
const RouterConfigSymbol = Symbol.for('EGG-MQTT#ROUTERCONFIG');

export = {
    get mqtt(): MqttClient {
        if (!this[MqttIOSymbol]) {
            this.config.mqtt.options = this.config.mqtt.options || {};
            const client: MqttClient = connect(this.config.mqtt.brokerUrl);
            try {
                client.route = (topic, handler) => {
                    if (!this[RouterConfigSymbol]) {
                        this[RouterConfigSymbol] = new Map();
                    }
                    if (!this[RouterConfigSymbol].has(topic)) {
                        myDebug('[egg-mqtt] set router config: ', topic);
                        this[RouterConfigSymbol].set(topic, handler);
                        this.mqtt.subscribe(topic, (err => {
                            if (err) {
                                this.logger.debug(err);
                            }
                        }))
                    }
                };
            } catch (e) {
                this.logger.error(e);
            }
            this[MqttIOSymbol] = client;
        }
        return this[MqttIOSymbol];
    }
};

