"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const debug_1 = require("debug");
const egg_core_1 = require("egg-core");
const events_1 = require("events");
const http = require("http");
const compose = require("koa-compose");
const CtxEventSymbol = Symbol.for('EGG-SOCKET.IO#CTX-EVENT');
const RouterConfigSymbol = Symbol.for('EGG-MQTT#ROUTERCONFIG');
function packetMiddlewareInit(app, mosca, packet, next, packetMiddlewares, nsp) {
    const request = mosca.request;
    request.mqtt = mosca;
    const ctx = app.createContext(request, new http.ServerResponse(request));
    ctx.packet = packet;
    ctx[CtxEventSymbol] = new events_1.EventEmitter();
    packetMiddlewares = packetMiddlewares.map((mw) => egg_core_1.utils.middleware(mw));
    const composed = compose(packetMiddlewares);
    composed(ctx, () => __awaiter(this, void 0, void 0, function* () {
        packet.push(ctx);
        next();
        const eventName = packet[0];
        const routerMap = nsp[RouterConfigSymbol];
        if (routerMap && routerMap.has(eventName)) {
            debug_1.debug('[egg-mqtt] wait controller finshed!');
            yield new Promise((resolve, reject) => {
                ctx[CtxEventSymbol].on('finshed', (error) => {
                    debug_1.debug('[egg-mqtt] controller execute finished, resume middlewares');
                    if (!error) {
                        resolve();
                    }
                    else {
                        reject(error);
                    }
                });
            });
        }
    }))
        .catch((e) => {
        next(e); // throw to the native socket.io
        app.coreLogger.error(e);
    });
}
exports.packetMiddlewareInit = packetMiddlewareInit;
;
